*** a/src/backend/access/transam/rmgr.c
--- b/src/backend/access/transam/rmgr.c
***************
*** 24,46 ****
  #include "storage/standby.h"
  #include "utils/relmapper.h"
  
  
  const RmgrData RmgrTable[RM_MAX_ID + 1] = {
! 	{"XLOG", xlog_redo, xlog_desc, NULL, NULL, NULL},
! 	{"Transaction", xact_redo, xact_desc, NULL, NULL, NULL},
! 	{"Storage", smgr_redo, smgr_desc, NULL, NULL, NULL},
! 	{"CLOG", clog_redo, clog_desc, NULL, NULL, NULL},
! 	{"Database", dbase_redo, dbase_desc, NULL, NULL, NULL},
! 	{"Tablespace", tblspc_redo, tblspc_desc, NULL, NULL, NULL},
! 	{"MultiXact", multixact_redo, multixact_desc, NULL, NULL, NULL},
! 	{"RelMap", relmap_redo, relmap_desc, NULL, NULL, NULL},
! 	{"Standby", standby_redo, standby_desc, NULL, NULL, NULL},
! 	{"Heap2", heap2_redo, heap2_desc, NULL, NULL, NULL},
! 	{"Heap", heap_redo, heap_desc, NULL, NULL, NULL},
! 	{"Btree", btree_redo, btree_desc, btree_xlog_startup, btree_xlog_cleanup, btree_safe_restartpoint},
! 	{"Hash", hash_redo, hash_desc, NULL, NULL, NULL},
! 	{"Gin", gin_redo, gin_desc, gin_xlog_startup, gin_xlog_cleanup, gin_safe_restartpoint},
! 	{"Gist", gist_redo, gist_desc, gist_xlog_startup, gist_xlog_cleanup, NULL},
! 	{"Sequence", seq_redo, seq_desc, NULL, NULL, NULL},
! 	{"SPGist", spg_redo, spg_desc, spg_xlog_startup, spg_xlog_cleanup, NULL}
  };
--- 24,32 ----
  #include "storage/standby.h"
  #include "utils/relmapper.h"
  
+ #define PG_RMGR(name,redo,desc,startup,cleanup,restartpoint) \
+ 	{ name, redo, desc, startup, cleanup, restartpoint },
  
  const RmgrData RmgrTable[RM_MAX_ID + 1] = {
! #include "access/rmgrlist.h"
  };
*** /dev/null
--- b/src/include/access/rmgrlist.h
***************
*** 0 ****
--- 1,39 ----
+ /*---------------------------------------------------------------------------
+  * rmgrlist.h
+  *
+  * The resource manager list is kept in its own source file for possible
+  * use by automatic tools.  The exact representation of a rmgr is determined
+  * by the PG_RMGR macro, which is not defined in this file; it can be
+  * defined by the caller for special purposes.
+  *
+  * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  * src/include/access/rmgrlist.h
+  *---------------------------------------------------------------------------
+  */
+ 
+ /* there is deliberately not an #ifndef RMGRLIST_H here */
+ 
+ /*
+  * List of resource manager entries.
+  */
+ 
+ /* name, redo, desc, startup, cleanup, restartpoint */
+ PG_RMGR("XLOG", xlog_redo, xlog_desc, NULL, NULL, NULL)
+ PG_RMGR("Transaction", xact_redo, xact_desc, NULL, NULL, NULL)
+ PG_RMGR("Storage", smgr_redo, smgr_desc, NULL, NULL, NULL)
+ PG_RMGR("CLOG", clog_redo, clog_desc, NULL, NULL, NULL)
+ PG_RMGR("Database", dbase_redo, dbase_desc, NULL, NULL, NULL)
+ PG_RMGR("Tablespace", tblspc_redo, tblspc_desc, NULL, NULL, NULL)
+ PG_RMGR("MultiXact", multixact_redo, multixact_desc, NULL, NULL, NULL)
+ PG_RMGR("RelMap", relmap_redo, relmap_desc, NULL, NULL, NULL)
+ PG_RMGR("Standby", standby_redo, standby_desc, NULL, NULL, NULL)
+ PG_RMGR("Heap2", heap2_redo, heap2_desc, NULL, NULL, NULL)
+ PG_RMGR("Heap", heap_redo, heap_desc, NULL, NULL, NULL)
+ PG_RMGR("Btree", btree_redo, btree_desc, btree_xlog_startup, btree_xlog_cleanup, btree_safe_restartpoint)
+ PG_RMGR("Hash", hash_redo, hash_desc, NULL, NULL, NULL)
+ PG_RMGR("Gin", gin_redo, gin_desc, gin_xlog_startup, gin_xlog_cleanup, gin_safe_restartpoint)
+ PG_RMGR("Gist", gist_redo, gist_desc, gist_xlog_startup, gist_xlog_cleanup, NULL)
+ PG_RMGR("Sequence", seq_redo, seq_desc, NULL, NULL, NULL)
+ PG_RMGR("SPGist", spg_redo, spg_desc, spg_xlog_startup, spg_xlog_cleanup, NULL)
